
#include <stdio.h>
#include <string.h>	
#include <avr/io.h>	
#include <avr/eeprom.h>	
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <ctype.h>
	
#include "mmc.h"
#include "fat16.h"

 void init_uart(void);

 int uart_putc(unsigned char);
 void uart_puts (char *);

 uint8_t uart_getc(void);
 void uart_gets( char *, uint8_t);

 








File *myfile;

void usart_write_P (const char *Buffer,...)
{
	va_list ap;
	va_start (ap, Buffer);	
	
	int format_flag;
	char str_buffer[10];
	char str_null_buffer[10];
	char move = 0;
	char Base = 0;
	int tmp = 0;
	char by;
	char *ptr;
		
	//Ausgabe der Zeichen
    for(;;)
	{
		by = pgm_read_byte(Buffer++);
		if(by==0) break; // end of format string
            
		if (by == '%')
		{
            by = pgm_read_byte(Buffer++);
			if (isdigit(by)>0)
				{
                                 
 				str_null_buffer[0] = by;
				str_null_buffer[1] = '\0';
				move = atoi(str_null_buffer);
                by = pgm_read_byte(Buffer++);
				}

			switch (by)
				{
                case 's':
                    ptr = va_arg(ap,char *);
                    while(*ptr) { uart_putc(*ptr++); }
                    break;
				case 'b':
					Base = 2;
					goto ConversionLoop;
				case 'c':
					//Int to char
					format_flag = va_arg(ap,int);
					uart_putc (format_flag++);
					break;
				case 'i':
					Base = 10;
					goto ConversionLoop;
				case 'o':
					Base = 8;
					goto ConversionLoop;
				case 'x':
					Base = 16;
					//****************************
					ConversionLoop:
					//****************************
					itoa(va_arg(ap,int),str_buffer,Base);
					int b=0;
					while (str_buffer[b++] != 0){};
					b--;
					if (b<move)
						{
						move -=b;
						for (tmp = 0;tmp<move;tmp++)
							{
							str_null_buffer[tmp] = '0';
							}
						//tmp ++;
						str_null_buffer[tmp] = '\0';
						strcat(str_null_buffer,str_buffer);
						strcpy(str_buffer,str_null_buffer);
						}
					uart_puts (str_buffer);
					move =0;
					break;
				}
			
			}	
		else
		{
			uart_putc ( by );	
		}
	}
	va_end(ap);
}






//Hauptprogramm
int main (void)
{
	

	//Initzialisierungen
	init_uart();
	

	PORTC=0xFF;
	DDRC=0xFF;
 	
	
	
	sei();
	

	//Statusmeldung
	usart_write_P(PSTR("System Ready!\r\n"));

	_delay_ms(100);
	_delay_ms(100);
	_delay_ms(100);	
	
	
	uart_puts("\n\n");	
	
		
	while ( mmc_init() !=0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
		{
		usart_write_P(PSTR("KeineSD\n"));	
		}
	uart_puts("SDok\n");
	 


	PORTC &= ~(1 << 7);	

	
	
	if(InitFat16())
	{
		uart_puts("FAT OK!!\n\n\r");
		PORTC&=~(1 << 6);
	
		myfile = fopen_("text1.txt",'a');
		
				

		if(myfile != NULL)
		{
		
				uart_puts("FILE OK!!");
				PORTC&=~(1 << 5);
																

				
				fputs_(myfile,"hallo");
				
				fclose_(myfile);

				
		}
	
	
	

	
	

	}	
	else
		usart_write_P(PSTR("noFAT!!\n"));
	
	usart_write_P(PSTR("FERTIG!!\r\n"));
 
//TIMSK=0x04;
 	

	//Hauptprogramm luft stndig in einer schleife und macht nichts
	while (1)
		{
		}
return (1);
}

//*******************************************************************************
//*******************************************************************************
//*******************************************************************************



//9600 Baud 8N1 @16 MHz
void init_uart()
{
	UCSRA=0x00;
	UCSRB=0x18;
	UCSRC=0x86;
	UBRRH=0x00;
	UBRRL=0x67;
}





int uart_putc(unsigned char c)
{
    while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
    {
    }                             
 
    UDR = c;                      /* sende Zeichen */
    return 0;
}


void uart_puts (char *s)
{
    while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
        uart_putc(*s);
        s++;
    }
}



uint8_t uart_getc(void)
{
    while (!(UCSRA & (1<<RXC)))   // warten bis Zeichen verfuegbar
        ;
    return UDR;                   // Zeichen aus UDR an Aufrufer zurueckgeben
}
 
void uart_gets( char* Buffer, uint8_t MaxLen )
{
  uint8_t NextChar;
  uint8_t StringLen = 0;
 
  NextChar = uart_getc();         // Warte auf und empfange das nchste Zeichen
 
                                  // Sammle solange Zeichen, bis:
                                  // * entweder das String Ende Zeichen kam
                                  // * oder das aufnehmende Array voll ist
  while( NextChar != '\n' && StringLen < MaxLen - 1 ) {
    *Buffer++ = NextChar;
    StringLen++;
    NextChar = uart_getc();
  }
                                 // Noch ein '\0' anhngen um einen Standard
                                  // C-String daraus zu machen
  *Buffer = '\0';
}
